function [V,T,beta] = lanczos(A,b,m)
beta = norm(b);
V(:,1) = b / beta;
w = A * V(:,1);
T(1,1) = dot(w, V(:,1)); w = w - T(1,1) * V(:,1); % orthogonalise
T(2,1) = norm(w); V(:,2) = w / T(2,1); % normalise 
for j = 2:m
    w = A*V(:,j); % Compute next vector
    
    % Orthogonalise against two previous columns 
    T(j-1,j) = T(j,j-1); % T is symmetric
    w = w - T(j-1,j) * V(:,j-1); % subtract the projection on V(:,j-1)
    T(j,j) = dot(w, V(:,j));
    w = w - T(j,j) * V(:,j); % subtract the projection on V(:,j)
    
    % Normalise
    T(j+1, j) = norm(w);
    
    % Record the new vector in V
    V(:, j+1) = w / T(j+1, j);
    
end